/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2010-2014 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *		vZbTˑW[iRL78j
 */
#pragma EI
#pragma DI
#include <kernel_impl.h>

/*
 *  ݔ񐔂ۑϐ
 */
uint8_t intnest;


/*
 *  (1) ReLXgɊւ`
 */


/*
 *  ReLXg̎Q
 */
bool_t
sense_context(void)
{
	/*  lXgJE^0Ȃ^XNReLXg  */
	return (intnest > 0);
}


/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNtÔ߂̕ϐ
 */
bool_t		lock_flag;		/* CPUbNtO̒lێϐ */
#if TMIN_INTPRI != -4
uint8_t 	saved_psw;		/* ݗDxxۑϐ */
#endif

/*
 *  CPU bNԂւ̈ڍs
 *      ̊֐́CCPU bNԂ̂ƂɌĂтȂƂOƂD
 */
void
t_lock_cpu(void)
{
#if TMIN_INTPRI == -4
	DI();
#else
	/* ^XNł͊ݗDx}XN̒l 0 ̂͂Ȃ̂ŕۑKvȂ */
	set_psw(PSW_SET_ISP(get_psw(), ISP_LOCK));
#endif
	lock_flag = true;
}

void
i_lock_cpu(void)
{
#if TMIN_INTPRI == -4
	DI();
#else
	uint8_t	psw;

	/*
	 *  get_psw() ̕Ԃl𒼐 saved_isp ɕۑCꎞϐ
	 *  psw ֕ۑ̂́Cget_psw() ̌ĂтɊ݂C
	 *  Nꂽݏ saved_isp ύX\邽߁D
	 */
	psw = get_psw();
	if (TIPM_LOCK < ISP2IPM(PSW2ISP(psw))) {
		set_psw(PSW_SET_ISP(psw, ISP_LOCK));
	}
	saved_psw = psw;
#endif
	lock_flag = true;
}

/*
 *  CPUbNԂ̉
 *      ̊֐́CCPU bNԂ̂Ƃɂ̂݌Ăт邱ƂOƂD
 */
void
t_unlock_cpu(void)
{
	lock_flag = false;
#if TMIN_INTPRI == -4
	EI();
#else
	/* ^XNs͊݃}XNSԂ̂͂Ȃ̂ŁCSɂĂ */
	set_psw(PSW_SET_ISP(get_psw(), ISP_ENAALL));
#endif
}

void
i_unlock_cpu(void)
{
	lock_flag = false;
#if TMIN_INTPRI == -4
	EI();
#else
	set_psw(PSW_SET_ISP(get_psw(), PSW2ISP(saved_psw)));
#endif
}

/*
 *  CPUbNԂ̎Q
 */
bool_t
x_sense_lock(void)
{
	return lock_flag;
}

/*
 *  ݗDx}XN(IPM) ̐ݒ
 *    w肵ݗDx(-1, -2, ..., TMIN_INTPRI) 
 *    vZbT̊ݗDxx (IPL) ݒ肷D
 */
void
x_set_ipm(PRI intpri)
{
	set_psw(PSW_SET_ISP(get_psw(), IPM2ISP(intpri)));
}

PRI
x_get_ipm(void)
{
	return (ISP2IPM(PSW2ISP(get_psw())));
}



/*
 *  (7) dispacher ł̊ݑ҂
 */
void
idle_loop(void)
{
	t_unlock_cpu();
	t_lock_cpu();
}


/*
 *  vZbTˑ̏
 */
void
prc_initialize(void)
{
}

/*
 *  vZbTˑ̏I
 */
void
prc_terminate(void)
{
	/* ɕKvȏ͂Ȃ */
}

/*
 *  ݗv֎~tÕZbg
 */
bool_t
x_disable_int(INTNO intno)
{
	volatile uint8_t *reg_addr;
	
	/* x`0łꍇCFG_INTĂȂ */
	if(intpri_table[intno] == 0U)
	{
		return (false);
	}
	// ݃}XNEtOEWX^̊Yrbg1ɃZbg
	if(intno < 32) {
		reg_addr = (volatile uint8_t *)TADR_MK0L;
		reg_addr += (intno/8);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_MK2L;
		reg_addr += ((intno-32) / 8);
	}
	*reg_addr |= (uint8_t)(1 << (intno % 8));
	
	return(true);
}

/*
 *  ݗv֎~tÕNA
 */
bool_t
x_enable_int(INTNO intno)
{
	volatile uint8_t *reg_addr;

	/* x`0łꍇCFG_INTĂȂ */
	if(intpri_table[intno] == 0u)
	{
		return (false);
	}
	// ݃}XNEtOEWX^̊Yrbg0ɃZbg
	if(intno < 32) {
		reg_addr = (volatile uint8_t *)TADR_MK0L;
		reg_addr += (intno/8);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_MK2L;
		reg_addr += ((intno-32) / 8);
	}
	*reg_addr &= (uint8_t)~(1 << (intno % 8));
	
	return(true);
}

/*
 *  ݗṽNA
 */
void
x_clear_int(INTNO intno)
{
	volatile uint8_t *reg_addr;

	// ݗvtOEWX^̊Yrbg0ɃZbg
	if(intno < 32) {
		reg_addr = (volatile uint8_t *)TADR_IF0L;
		reg_addr += (intno/8);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_IF2L;
		reg_addr += ((intno-32) / 8);
	}
	*reg_addr &= (uint8_t)~(1 << (intno % 8));
}

/*
 *  ݗṽ`FbN
 */
bool_t
x_probe_int(INTNO intno)
{
	volatile uint8_t *reg_addr;

	// ݗvtOEWX^̊Yrbg 1 Ȃ true
	if(intno < 32) {
		reg_addr = (volatile uint8_t *)TADR_IF0L;
		reg_addr += (intno/8);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_IF2L;
		reg_addr += ((intno-32) / 8);
	}

	return((*reg_addr & (uint8_t)(1 << (intno % 8))) != 0);
}

/*
 *  ݗvC̑̐ݒ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	volatile uint8_t *reg_addr;
	uint8_t portno;

	assert(VALID_INTNO_CFGINT(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  ݂̃}XN
	 *
	 *  ݂󂯕t܂܁CxgK^GbWgK̐ݒC
	 *  ݗDx̐ݒŝ͊댯Ȃ߁Cݑɂ炸C
	 *  U}XND
	 */
	(void) x_disable_int(intno);

	/*
	 * Dx̐ݒ
	 */
	// D揇ʎwtOEWX^̊YrbgɒlZbg
	if(intno < 32) {
		reg_addr = (volatile uint8_t *)TADR_PR00L;
		reg_addr += (intno/8);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_PR02L;
		reg_addr += ((intno-32) / 8);
	}
	// D揇ʃx̐ݒ(ʃrbg)
	if((IPM2ILVL(intpri) & 0x01) != 0) {
		*reg_addr |= (uint8_t)(1 << (intno % 8));
	}
	else {
		*reg_addr &= (uint8_t)~(1 << (intno % 8));
	}
	// D揇ʃx̐ݒ(ʃrbg)
	if((IPM2ILVL(intpri) & 0x02) != 0) {
		*(reg_addr+4) |= (uint8_t)(1 << (intno % 8));
	}
	else {
		*(reg_addr+4) &= (uint8_t)~(1 << (intno % 8));
	}
	
	/*
	 * gK̐ݒ
	 */
	if(intno <= 7) {
		reg_addr = (volatile uint8_t *)TADR_EGP0;	// EGP0
		portno = (uint8_t)(intno - 2);
	}
	else {
		reg_addr = (volatile uint8_t *)TADR_EGP1;	// EGP1
		portno = (uint8_t)(intno - 29);
	}
	
	/* INT[q̏ꍇ͊݌m@ݒ肷 */
	if((intatr & TA_POSEDGE) != 0U)
	{
		// OݗオGbWWX^̊Yrbg1ɃZbg
		*reg_addr |= (uint8_t)(1 << (portno % 8));
		// OݗGbWWX^̊Yrbg0ɃZbg
		*(reg_addr+1) &= (uint8_t)~(1 << (portno % 8));
	}
	else if((intatr & TA_NEGEDGE) != 0U)
	{
		// OݗオGbWWX^̊Yrbg0ɃZbg
		*reg_addr &= (uint8_t)~(1 << (portno % 8));
		// OݗGbWWX^̊Yrbg1ɃZbg
		*(reg_addr+1) |= (uint8_t)(1 << (portno % 8));
	}
	else if((intatr & TA_BOTHEDGE) != 0U)
	{
		// OݗオGbWWX^̊Yrbg1ɃZbg
		*reg_addr |= (uint8_t)(1 << (portno % 8));
		// OݗGbWWX^̊Yrbg1ɃZbg
		*(reg_addr+1) |= (uint8_t)(1 << (portno % 8));
	}
	else {	// ǂłȂꍇ̓GbWo֎~
		// OݗオGbWWX^̊Yrbg0ɃZbg
		*reg_addr &= (uint8_t)~(1 << (portno % 8));
		// OݗGbWWX^̊Yrbg0ɃZbg
		*(reg_addr+1) &= (uint8_t)~(1 << (portno % 8));
	}

	/*
	 *  ݂̃}XN(Dxݒ)
 	 */
	if ((intatr & TA_ENAINT) != 0U) {
		(void) x_enable_int(intno);
	}
}

/*
 *  NMIׂĂ݂̊̋֎~
 */
uint8_t
TOPPERS_disint(void)
{
	volatile uint8_t	TOPPERS_psw;

	TOPPERS_psw = get_psw();
	DI();
	return(TOPPERS_psw);
}

/*
 *  ݗDx}XNi\ǰݒl̐ݒ
 */
void
TOPPERS_enaint(uint8_t TOPPERS_psw)
{
	if(TOPPERS_psw & PSW_IE_MASK)
	{
		EI();
	}
}


